#!/usr/bin/perl -w

#getFragLen.pl bamfile1 bamfile2 bamfile3 chr outfile

use Data::Dumper;
use strict;
use warnings;

my $bam_fh = shift; #bamfile
my $bam_fh2 = shift; #bamfile
my $bam_fh3 = shift; #bamfile
my $chr = shift;
my $outfile = shift;

open(my $outf, ">>", $outfile);

my $maxFrag = 501;

my %fsums = ();
my %fnums = ();

my %rsums = ();
my %rnums = ();

open BAM, "samtools view $bam_fh |" or die "can t open <samtools view
$bam_fh | ... >\n";
while(<BAM>){
    chomp;
    my @F=split"\t",$_;
    my ($bitflag, $chr, $leftpos, $cigar, $pnext, $fraglength, $rnext) =
	($F[1], $F[2], $F[3], $F[5], $F[7], $F[8], $F[6]);
    my $cigarlength = &cigarlength($cigar);
    
    next if ($pnext == 0);
    next if ($fraglength == 0);
    next if ($rnext ne "=");

    
    if( ($bitflag & 1) && ($bitflag & 2) && ($bitflag & 16) && !($bitflag
								 & 32) && ($bitflag & 64)  ){  # $bitflag == 83, read reverse strand, mate fwd, gene rev
	my $readEnd = $leftpos + $cigarlength -1;
	my $mateEnd = $pnext; #matches annotated 3'?
	
	next if (  ($readEnd - $mateEnd) < 0 || ($readEnd - $mateEnd) >
		   $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($rsums{$mateEnd})){$rsums{$mateEnd}+=$FRAGMENTLAENGE; $rnums{$mateEnd} += 1;}
	else{$rsums{$mateEnd}=$FRAGMENTLAENGE; $rnums{$mateEnd} = 1;}
	    
    }
    elsif( ($bitflag & 1) && ($bitflag & 2) && !($bitflag & 16) &&
	   ($bitflag & 32) && ($bitflag & 64)  ){  # $bitflag == 99, read fwd strand, mate reverse, gene fwd
	my $readEnd = $leftpos;
	my $mateEnd = $leftpos + $fraglength - 1; ##matches with annotated 3'?
	
	next if ( ($mateEnd - $readEnd) < 0  || ($mateEnd - $readEnd) >
		  $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($fsums{$mateEnd})){$fsums{$mateEnd}+=$FRAGMENTLAENGE; $fnums{$mateEnd} += 1;}
	else{$fsums{$mateEnd}=$FRAGMENTLAENGE; $fnums{$mateEnd} = 1;}
	    
    }
    ##add position and 
}
close BAM;

##S2
my %fsums2 = ();
my %fnums2 = ();

my %rsums2 = ();
my %rnums2 = ();

open BAM2, "samtools view $bam_fh2 |" or die "can t open <samtools view
$bam_fh2 | ... >\n";
while(<BAM2>){
    chomp;
    my @F=split"\t",$_;
    my ($bitflag, $chr, $leftpos, $cigar, $pnext, $fraglength, $rnext) =
	($F[1], $F[2], $F[3], $F[5], $F[7], $F[8], $F[6]);
    my $cigarlength = &cigarlength($cigar);
    
    next if ($pnext == 0);
    next if ($fraglength == 0);
    next if ($rnext ne "=");

    
    if( ($bitflag & 1) && ($bitflag & 2) && ($bitflag & 16) && !($bitflag
								 & 32) && ($bitflag & 64)  ){  # $bitflag == 83, read reverse strand, mate fwd, gene rev
	my $readEnd = $leftpos + $cigarlength -1;
	my $mateEnd = $pnext; #matches annotated 3'?
	
	next if (  ($readEnd - $mateEnd) < 0 || ($readEnd - $mateEnd) >
		   $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($rsums2{$mateEnd})){$rsums2{$mateEnd}+=$FRAGMENTLAENGE; $rnums2{$mateEnd} += 1;}
	else{$rsums2{$mateEnd}=$FRAGMENTLAENGE; $rnums2{$mateEnd} = 1;}
	    
    }
    elsif( ($bitflag & 1) && ($bitflag & 2) && !($bitflag & 16) &&
	   ($bitflag & 32) && ($bitflag & 64)  ){  # $bitflag == 99, read fwd strand, mate reverse, gene fwd
	my $readEnd = $leftpos;
	my $mateEnd = $leftpos + $fraglength - 1; ##matches with annotated 3'?
	
	next if ( ($mateEnd - $readEnd) < 0  || ($mateEnd - $readEnd) >
		  $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($fsums2{$mateEnd})){$fsums2{$mateEnd}+=$FRAGMENTLAENGE; $fnums2{$mateEnd} += 1;}
	else{$fsums2{$mateEnd}=$FRAGMENTLAENGE; $fnums2{$mateEnd} = 1;}
	    
    }
}
close BAM2;


##S3
my %fsums3 = ();
my %fnums3 = ();

my %rsums3 = ();
my %rnums3 = ();

open BAM3, "samtools view $bam_fh3 |" or die "can t open <samtools view
$bam_fh3 | ... >\n";
while(<BAM3>){
    chomp;
    my @F=split"\t",$_;
    my ($bitflag, $chr, $leftpos, $cigar, $pnext, $fraglength, $rnext) =
	($F[1], $F[2], $F[3], $F[5], $F[7], $F[8], $F[6]);
    my $cigarlength = &cigarlength($cigar);
    
    next if ($pnext == 0);
    next if ($fraglength == 0);
    next if ($rnext ne "=");

    
    if( ($bitflag & 1) && ($bitflag & 2) && ($bitflag & 16) && !($bitflag
								 & 32) && ($bitflag & 64)  ){  # $bitflag == 83, read reverse strand, mate fwd, gene rev
	my $readEnd = $leftpos + $cigarlength -1;
	my $mateEnd = $pnext; #matches annotated 3'?
	
	next if (  ($readEnd - $mateEnd) < 0 || ($readEnd - $mateEnd) >
		   $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($rsums3{$mateEnd})){$rsums3{$mateEnd}+=$FRAGMENTLAENGE; $rnums3{$mateEnd} += 1;}
	else{$rsums3{$mateEnd}=$FRAGMENTLAENGE; $rnums3{$mateEnd} = 1;}
	    
    }
    elsif( ($bitflag & 1) && ($bitflag & 2) && !($bitflag & 16) &&
	   ($bitflag & 32) && ($bitflag & 64)  ){  # $bitflag == 99, read fwd strand, mate reverse, gene fwd
	my $readEnd = $leftpos;
	my $mateEnd = $leftpos + $fraglength - 1; ##matches with annotated 3'?
	
	next if ( ($mateEnd - $readEnd) < 0  || ($mateEnd - $readEnd) >
		  $maxFrag );
	
	my $FRAGMENTLAENGE = abs( $mateEnd - $readEnd);
	if(exists($fsums3{$mateEnd})){$fsums3{$mateEnd}+=$FRAGMENTLAENGE; $fnums3{$mateEnd} += 1;}
	else{$fsums3{$mateEnd}=$FRAGMENTLAENGE; $fnums3{$mateEnd} = 1;}
	    
    }
}
close BAM3;








foreach my $fk (sort (keys %fsums)){
    my $allsum = 0;
    my $allnum = 0;
    if($fnums{$fk} < 4){next;}
    $allsum += $fsums{$fk};
    $allnum += $fnums{$fk};
    if(exists($fsums2{$fk}))
    {
	if($fnums2{$fk} < 4){next;}
	$allsum += $fsums2{$fk};
	$allnum += $fnums2{$fk};
    }
    else{next;}
    if(exists($fsums3{$fk}))
    {
        if($fnums3{$fk} < 4){next;}
	$allsum += $fsums3{$fk};
	$allnum += $fnums3{$fk};
    }
    else{next;}
    my $fav = 0;
    $fav = sprintf("%.3f",$allsum/$allnum);
    my $fk1 = $fk+1;
    print $outf "$chr\t$fk\t$fk1\t$fav\trotemV2pos\t+\t$allnum\n";
}


foreach my $rk (sort (keys %rsums)){
    my $allsum = 0;
    my $allnum = 0;
    if($rnums{$rk} < 4){next;}
    $allsum += $rsums{$rk};
    $allnum += $rnums{$rk};
    if(exists($rsums2{$rk}))
    {
	if($rnums2{$rk} < 4){next;}
	$allsum += $rsums2{$rk};
	$allnum += $rnums2{$rk};
    }
    else{next;}
    if(exists($rsums3{$rk}))
    {
        if($rnums3{$rk} < 4){next;}
	$allsum += $rsums3{$rk};
	$allnum += $rnums3{$rk};
    }
    else{next;}
    my $rav = 0;
    $rav = sprintf("%.3f",$allsum/$allnum);
    my $rk1 = $rk+1;
    print $outf "$chr\t$rk\t$rk1\t$rav\trotemV2pos\t-\t$allnum\n";
}






sub cigarlength {
    my $cigar_string = shift;
    my $cigar_length = 0;
    
    while($cigar_string=~m/(\d+)[MDX=N]/g){
	$cigar_length+=$1;
    }
    
    if($cigar_length == 0) {
	print STDERR "Warning from &cigarlength: CIGAR string
<'$cigar_string'> seems corrupt;\n";
	return(0);
    }
    return($cigar_length);
}
