#! /bin/bash
#argument: file containing names of bedgraph files with 3'ends
for i in `cat $1`; do perl callthesepeaks.pl ${i}| sort -V > ${i}.peaks; done
for i in `cat $1`; do perl collectthesplicer.pl ${i}.peaks  > ${i}.collected; done
## FILTER for zscore ($minz, here 2) and min coverage ($mincov, here 5). Change parameters here if needed
for i in `cat $1`; do cat ${i}.collected | perl -wlane 'BEGIN{$minz=2; $mincov=5;}print $_ if($F[-1]>$minz && $F[3]>=$mincov)' >  ${i}_5min.gt2andzs2gt2filtered; bedtools merge -d 10 -c 4,5,6 -o collapse,mean,mean -i ${i}_5min.gt2andzs2gt2filtered > ${i}_5min.gt2andzs2gt2merged; done

for i in `cat $1`; do bedtools intersect -wo -a ${i}_5min.gt2andzs2gt2merged -b ${i}.background.bg  | perl -wlane '@x=split(/,/,$F[3]); $sum=0; for ($i=0; $i<= $#x; $i++) {$sum+=$x[$i]; } $sum/=$F[9]; print "$F[0]\t$F[1]\t$F[2]\t$F[3]\t$F[4]\t$F[5]\t$F[9]\t$sum";' > ${i}.againstbackground_5min.bed; done
for i in `cat $1`; do bedtools merge -c 8 -o mean -i ${i}.againstbackground_5min.bed > ${i}.againstbackground.merged_5min.bed; done

#FILTER for min coverage relative to background ($cutoff, here: 10%) Change parameters here if needed
for i in `cat $1`; do cat ${i}.againstbackground.merged_5min.bed | perl -wlane 'BEGIN{$cutoff=10;}print $_ if ($F[-1]>($cutoff/100));' > ${i}_5min.10perzmin; done
